aboutsummaryrefslogtreecommitdiff
path: root/gen/prop/bmg
diff options
context:
space:
mode:
Diffstat (limited to 'gen/prop/bmg')
-rwxr-xr-xgen/prop/bmg54
1 files changed, 54 insertions, 0 deletions
diff --git a/gen/prop/bmg b/gen/prop/bmg
new file mode 100755
index 0000000..ae5beff
--- /dev/null
+++ b/gen/prop/bmg
@@ -0,0 +1,54 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_bmg.c
+
+gawk '
+BEGIN {
+ FS = " *(; *|#.*)"
+
+ print "/* This file is autogenerated by gen/prop/bmg; DO NOT EDIT. */"
+ print ""
+ print "#include \"__bsearch.h\""
+ print "#include \"macros.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+/^[^#]/ {
+ props[strtonum("0X" $1)] = strtonum("0X" $2)
+}
+
+END {
+ print "static constexpr rune lookup_lat1[] = {"
+ for (i = 0; i < 0x100; i++) {
+ if (i % 8 == 0)
+ printf "\t"
+ printf "0x%02X,%s", (props[i] ? props[i] : 0), \
+ i % 8 == 7 ? "\n" : " "
+ }
+ print "};"
+ print ""
+ print "static const struct {"
+ print "\trune k, v;"
+ print "} lookup[] = {"
+
+ for (i = 0x100; i <= 0x10FFFF; i++) {
+ if (!props[i])
+ continue
+ printf "\t{RUNE_C(0x%06X), RUNE_C(0x%06X)},\n", i, props[i]
+ }
+
+ print "};"
+ print ""
+ print "__MLIB_DEFINE_BSEARCH_KV(rune, lookup, 0)"
+ print ""
+ print "rune"
+ print "uprop_get_bmg(rune ch)"
+ print "{"
+ print "\treturn ch < lengthof(lookup_lat1) ? lookup_lat1[ch] : mlib_lookup_kv(ch);"
+ print "}"
+}
+' data/BidiMirroring